unit IccpUtil;

{$IMPORTEDDATA OFF}

interface

function GetICCProfileDesc(buf: PChar; size: Cardinal): string;

implementation

uses NTypes, NLib;

function GetICCProfileDesc(buf: PChar; size: Cardinal): string;
var
  tagcount, ofs, len: Cardinal;
  p, pp: PChar;
  ws: WideString;
  i: Integer;
begin
  Result := '';
  // header + tag count + one tag table
  if size <= (128 + 4 + 12) then Exit;

  p := buf;
  Inc(p, 128);
  tagcount := Be32ToH(PUInt32(p)^);
  Inc(p, 4);

  while (tagcount > 0) and (p < @buf[size - 12]) do begin
    if not (PUInt32(p)^ = PUInt32(PChar('desc'))^) then begin
      Inc(p, 12);
      Dec(tagcount);
      Continue;
    end;

    Inc(p, 4);
    ofs := Be32ToH(PUInt32(p)^);
    if ofs >= (size - 12) then Exit;

    p := @buf[ofs];

    if PUInt32(p)^ = PUInt32(PChar('desc'))^ then begin
      Inc(p, 8);
      len := Be32ToH(PUInt32(p)^);
      Inc(p, 4);
      if PChar(@p[len]) > @buf[size] then Exit;
      SetString(Result, p, len);
      Exit;
    end;

    if PUInt32(p)^ = PUInt32(PChar('mluc'))^ then begin
      pp := p;
      Inc(pp, 20);
      if pp > @buf[size - 8] then Exit;
      len := Be32ToH(PUInt32(pp)^);
      Inc(pp, 4);
      Inc(p, Be32ToH(PUInt32(pp)^));
      if PChar(@p[len]) > @buf[size] then Exit;
      SetString(ws, nil, len div 2);
      for i := 1 to len div 2 do
        ws[i] := WideChar(Byte(p[i*2-1]) or (Byte(p[i*2-2]) shl 8));
      Result := ws;
      Exit;
    end;

    Exit;
  end;
end;

end.
