unit WincodecSub;

{$IMPORTEDDATA OFF}
{$MINENUMSIZE 4}

interface

uses Windows, ActiveX;

const
  CLSID_WICImagingFactory: TGUID = '{CACAF262-9370-4615-A13B-9F5539DA4C0A}';
  GUID_ContainerFormatWebp: TGUID = '{E094B0E2-67F2-45B3-B0EA-115337CA7CF3}';
  GUID_WICPixelFormat32bppRGBA: TGUID = '{f5c7ad2d-6a8d-43dd-a7a8-a29935261ae9}';

type
  WICColorContextType = (
    WICColorContextUninitialized = 0,
    WICColorContextProfile = $1,
    WICColorContextExifColorSpace = $2
  );

  IWICStream = interface(IStream)
    ['{135FF860-22B7-4ddf-B0F6-218F4F299A43}']
    function InitializeFromStream(out Stream: IStream): HRESULT; stdcall;
    function InitializeFromFilename(wzFilename: LPCWSTR; dwDesiredAcess: DWORD):
        HRESULT; stdcall;
    function InitializeFromMemory(pbBuffer: Pointer; cbBufferSize: DWORD):
        HRESULT; stdcall;
  end;

  IWICBitmapSource = interface(IUnknown)
    ['{00000120-A8F2-4877-BA0A-FD2B6645FB94}']
    function GetSize(out Width: UINT; out Height: UINT): HRESULT; stdcall;
    function GetPixelFormat(out PixelFormat: TGUID): HRESULT; stdcall;
    function GetResolution(out DpiX: Double; DpiY: Double): HRESULT; stdcall;
    function CopyPalette: HRESULT; stdcall;
    function CopyPixels(PRc: Pointer; cbStride: UINT; cbBufferSize: UINT;
        Buffer: Pointer): HRESULT; stdcall;
  end;

  IWICColorContext = interface(IUnknown)
    ['{3C613A02-34B2-44ea-9A7C-45AEA9C6FD6D}']
    function InitializeFromFilename(wzFilename: LPCWSTR): HRESULT; stdcall;
    function InitializeFromMemory: HRESULT; stdcall;
    function InitializeFromExifColorSpace(value: UINT): HRESULT; stdcall;
    function GetType(out Type_: WICColorContextType): HRESULT; stdcall;
    function GetProfileBytes(cbBuffer: UINT; pbBuffer: PByte;
        out cbActual: UINT): HRESULT; stdcall;
  end;

  IWICColorTransform = interface(IWICBitmapSource)
    ['{B66F034F-D0E2-40ab-B436-6DE39E321A94}']
    function Initialize(BitmapSource: IWICBitmapSource;
      ContextSource: IWICColorContext; ContextDest: IWICColorContext;
      const pixelFmtDest: TGUID): HRESULT; stdcall;
  end;

  IWICBitmapFrameDecode = interface(IWICBitmapSource)
    ['{3B16811B-6A43-4ec9-A813-3D930C13B940}']
    function GetMetadataQueryReader: HRESULT; stdcall;
    function GetColorContexts(Count: UINT; var ColorContexts: IWICColorContext;
        out ActualCount:UINT): HRESULT; stdcall;
  end;

  IWICBitmapDecoder = interface(IUnknown)
    ['{9edde9e7-8dee-47EA-99df-e6faf2ed44bf}']
    function QueryCapability: HRESULT; stdcall;
    function Initialize(Stream: IStream; cacheOptions: Cardinal): HRESULT; stdcall;
    function GetContainerFormat: HRESULT; stdcall;
    function GetDecoderInfo: HRESULT; stdcall;
    function CopyPalette: HRESULT; stdcall;
    function GetMetadataQueryReader: HRESULT; stdcall;
    function GetPreview: HRESULT; stdcall;
    function GetColorContexts: HRESULT; stdcall;
    function GetThumbnail: HRESULT; stdcall;
    function GetFrameCount: HRESULT; stdcall;
    function GetFrame(Index: UINT; out BitmapFrame: IWICBitmapFrameDecode):
        HRESULT; stdcall;
  end;

  IWICImagingFactory = interface(IUnknown)
    ['{EC5EC8A9-C395-4314-9C77-54D7A935FF70}']
    function CreateDecorderFromFilename: HRESULT; stdcall;
    function CreateDecorderFromStream: HRESULT; stdcall;
    function CreateDecorderFromFileHandle: HRESULT; stdcall;
    function CreateComponentInfo: HRESULT; stdcall;
    function CreateDecoder(const guidContainerFormat: TGUID; pguidVendor: PGUID;
        out Decoder: IWICBitmapDecoder): HRESULT; stdcall;
    function CreateEncoder: HRESULT; stdcall;
    function CreatePalette: HRESULT; stdcall;
    function CreateFormatConverter: HRESULT; stdcall;
    function CreateBitmapScaler: HRESULT; stdcall;
    function CreateBitmapClipper: HRESULT; stdcall;
    function CreateFripRotator: HRESULT; stdcall;
    function CreateStream(out WICStream: IWICStream): HRESULT; stdcall;
    function CreateColorContext(out WICColorContext: IWICColorContext):
        HRESULT; stdcall;
    function CreateColorTransformer(out WICColorTransform: IWICColorTransform):
        HRESULT; stdcall;
  end;

implementation
end.
